var test = require('tap').test;
var parsley = require('../');
var chunky = require('chunky');
var Stream = require('net').Stream;

test('connect upgrade', function (t) {
    var pending = 50;
    t.plan(50 * 2);
    
    Array(50+1).join('x').split('').forEach(function () {
        var stream = new Stream;
        stream.readable = true;
        
        var p = parsley(stream, function (req) {
            req.on('headers', function () {
                p.upgrade();
            });
            
            req.on('upgrade', function () {
                t.ok(true);
            });
            
            var data = '';
            req.on('data', function (buf) {
                data += buf;
            });
            
            req.on('end', function () {
                t.equal(data, 'beep!\r\nbeep!');
                if (--pending === 0) t.end();
            });
        });
        
        var msg = new Buffer([
            'CONNECT localhost:5000 HTTP/1.1',
            'Host: beep.boop',
            '',
            'beep!',
            'beep!',
        ].join('\r\n'));
        
        var chunks = chunky(msg);
        var iv = setInterval(function () {
            stream.emit('data', chunks.shift());
            if (chunks.length === 0) {
                stream.emit('end');
                clearInterval(iv);
            }
        }, 10);
    });
});
